;*------------------------------------------------------------------------------
;*
;*  AUTOR: Andrzej Okrutny <anok@ceti.pl>
;*         www.anok.ceti.pl
;*
;*  hardware: AT89C2051
;*  OSC:      12 MHz
;*------------------------------------------------------------------------------


LED	equ	P3.7

stack	equ	020h




	SEG CODE

	org	0000h
	jmp	main


	org	0020h


;*
;* IN: dptr
;*

delay_ms PROC

	push	acc

	xrl	dph, #0ffh
	xrl	dpl, #0ffh
	inc	dptr

	; ------------------------------------

L?1	push	dpl		; 2
	mov	dpl, #182	; 2
L?2	nop			; 1
	nop			; 1
	nop			; 1
	djnz	dpl, L?2	; 2
	pop	dpl 		; 2

	inc	dptr		; 2 
	mov	a, dph		; 1
	jnz	L?1		; 2

	pop	acc

	ret
	ENDPROC


;*****************************************************************************
;*
;*	MAIN PROGRAM
;*
;*****************************************************************************

main	PROC

	mov	sp, #stack

	clr	RS0
	clr	RS1

; clear internal RAM

	mov	r0, #0ffh
	clr	a
L?nx	mov	@r0, a
	djnz	r0, L?nx


; main loop

L?loop	clr	LED

	mov	dptr, #500
	call	delay_ms
	
	setb	LED

	mov	dptr, #500
	call	delay_ms


	jmp	L?loop	



	ENDPROC

	END
